#!/bin/bash

#$1: decide-vm name
#$2: decide-vm external_ip_address
#$3: decide-vm internal_ip_address
#$4: wan consul-join-ip i
#Optional arguments:
#$5: Private Docker registry ip
#$6: Private Docker registry port
chmod +x /tmp/scripts/install-docker-and-compose.sh
chmod +x /tmp/scripts/configure-sec.sh
chmod +x /tmp/scripts/install-and-run-consul.sh
echo "Configuring security..." >> /tmp/scripts/install.log
/tmp/scripts/configure-sec.sh $2
echo "...security configuration done"  >> /tmp/scripts/install.log
echo "installing docker and docker-compose..."  >> /tmp/scripts/install.log
/tmp/scripts/install-docker-and-compose.sh
echo "...docker and docker-compose installation done"  >> /tmp/scripts/install.log
echo "Configuring docker as service..."  >> /tmp/scripts/install.log
sudo cp /tmp/scripts/docker.service /lib/systemd/system/docker.service
sudo systemctl daemon-reload
sudo systemctl restart docker
echo "...docker configuration as a service done"  >> /tmp/scripts/install.log
echo "Installing and running consul..." >> /tmp/scripts/install.log
/tmp/scripts/install-and-run-consul.sh $1 $2 $3
echo "..consul installed" >> /tmp/scripts/install.log
echo "Joining the wan cluster at ..." >> /tmp/scripts/install.log
consul join -http-addr=$3:8500 -wan $4
echo "...cluster joined" >> /tmp/scripts/install.log
if [ $# -ge 6 ]
  then
    /tmp/scripts/registry/configure-registry-cert.sh $5 $6
fi
