#!/bin/bash
sudo apt-get install -f
sudo apt-get update -y

if [ $? != 0 ]; 
then
    echo "apt-get update failed with code $?. Retrying..."  >> /tmp/scripts/install.log
    sleep 3
    sudo rm -rf /var/lib/apt/lists/* -vf
    sudo apt-get install -f && sudo apt-get update -y || echo "apt-get update failed *again* with code $?. Giving off..." >> /tmp/scripts/install.log
fi

while fuser /var/lib/dpkg/lock >/dev/null 2>&1 ; do
  echo "...waiting for /var/lib/dpkg/lock unlock... " >> /tmp/scripts/install.log
  sleep 0.5
done
sudo apt-get install \
    apt-transport-https \
    ca-certificates \
    curl \
    software-properties-common -y

curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo apt-key add -

while fuser /var/lib/dpkg/lock >/dev/null 2>&1 ; do
  echo "...waiting for /var/lib/dpkg/lock unlock... " >> /tmp/scripts/install.log
  sleep 0.5
done

sudo add-apt-repository \
   "deb [arch=amd64] https://download.docker.com/linux/ubuntu \
   $(lsb_release -cs) \
   stable"
   
while fuser /var/lib/dpkg/lock >/dev/null 2>&1 ; do
  echo "...waiting for /var/lib/dpkg/lock unlock... " >> /tmp/scripts/install.log
  sleep 0.5
done

sudo apt-get update -y

while fuser /var/lib/dpkg/lock >/dev/null 2>&1 ; do
  echo "...waiting for /var/lib/dpkg/lock unlock... " >> /tmp/scripts/install.log
  sleep 0.5
done

sudo apt-get install docker-ce -y

sudo curl -o /usr/local/bin/docker-compose -L "https://github.com/docker/compose/releases/download/1.11.2/docker-compose-$(uname -s)-$(uname -m)"
sudo chmod +x /usr/local/bin/docker-compose
sudo docker-compose -v
